<template>

  <div class="sw-gs-widget-il">

    <div class="sw-gs-il-actions-wrapper" v-if="instantListingProducts && instantListingProducts.length">
      <div class="sw-gs-il-actions-content">
        <template v-if="isCreationMode === false">
          <SwCheckbox :label="$t('sync')"
          :title="$t('The listing will be automatically synchronized')"
          :selected="autoSyncProducts"
          @change="toggleAutoProductSync()"/>
          <SwButton
          class="sw-gs-update-il-btn color-primary"
          :title="$t('Update Current Listing')"
          :disabled="instantListingSaving || (instantListingUpdated && instantListingUpdated.updated)"
          @click="saveInstantListingUpdate">
          <template v-if="instantListingSaving || (instantListingUpdated && instantListingUpdated.updated)">
            <SfLoader :loading="true" />
          </template>
          <template v-else>
            <span>{{ $t('Update Current Listing') }}</span>
          </template>
        </SwButton>
        
        </template>
        <template v-else>
          <h5 class="slide-info">{{ $t('New Slide') }} ({{ indexOfFirstSlideInNextGroup }})</h5>
          <div class="sw-gs-show-il-create-btns">
            <SwButton class="sw-gs-show-il-create-btn color-primary"
              v-if="indexOfFirstSlideInNextGroup !== 1"
              :title="$t('Create New Listing at Slide') + ' ' + indexOfFirstSlideInNextGroup"
              @click="saveNewInstantListing(false)">
              <sw-gs-icon-save  class="color-dark-secondary size-sm"></sw-gs-icon-save>
            </SwButton>
            <SwButton class="sw-gs-show-il-navigate-btn color-primary"
              :title="$t('Create New Listing at Slide') + ' ' + indexOfFirstSlideInNextGroup + ' & ' + $t('Go To New Slide')"
              @click="saveNewInstantListing(true)">
              <sw-gs-icon-save  class="color-dark-secondary size-sm"></sw-gs-icon-save>
                &nbsp;&nbsp;
              <sw-gs-icon-long-arrow-right  class="color-dark-secondary size-sm"></sw-gs-icon-long-arrow-right>
            </SwButton>
          </div>
        </template>
      </div>
      <div class="sw-gs-il-actions-sub-content">
        <h4 class="sw-gs-il-actions-sub-content-title">{{ $t('Products') }} ({{instantListingProducts.length}})</h4>
        <a
          :class="{
            'sw-gs-il-actions-sub-content-remove-btn': true,
            'sw-gs-prevent-click': instantListingSaving || (instantListingUpdated && instantListingUpdated.updated)
          }"
          @click="removeAllSelectedProducts()"
        >
          {{ $t('Remove all') }}
        </a>
      </div>
    </div>

    <div :class="{
      'sw-gs-il-products-wrapper': true,
      'sw-gs-prevent-click': instantListingSaving || (instantListingUpdated && instantListingUpdated.updated)
    }">
      <div v-for="product in currentProducts" :key="product.id" class="sw-gs-il-product-card-wrapper">
        <SwPluginSlot name="gs-il-guide-product-card" :slot-context="{product, hideActions: true}">
          <SwGsLayerProductCard :product="product" :actions="false" @click="toggleProduct(product)"></SwGsLayerProductCard>
        </SwPluginSlot>
        <SwCheckbox :selected="isProductSelected(product.id)" @change="toggleProduct(product)"/>
      </div>
      <div v-if="showLoadMoreController" class="sw-gs-il-products-wrapper-bottom">
        <SfLoader :loading="scrollLoading" />
        <button ref="loadMoreButton">
          {{ $t("load more") }}...
        </button>
      </div>
    </div>

    <div class="sw-gs-il-init-filters-wrapper">
      <div class="sw-gs-il-product-streams-wrapper">
        <h5 class="sw-gs-il-product-stream-headline">{{ $t('Preselect product streams') }}</h5>
        <div class="sw-gs-il-product-stream"
             v-for="stream in productStreams"
             :key="stream.id">
          <SwCheckbox :label="stream.name"
                      :selected="isInProductStreamArray(stream.id)"
                      @change="toggleProductStreamSelection(stream)"/>
        </div>
      </div>
    </div>

  </div>
</template>

<script lang="ts">
  import {useInstantListing} from "../../logic/composables/useInstantListing";
  import {SwGsIconBroadcast} from "../icons";
  import SwCheckbox from "@/components/atoms/SwCheckbox.vue";
  import {SfSelect, SfLoader} from "@storefront-ui/vue";
  import SwGsLayerProductCardHorizontal from "../layer/SwGsLayerProductCardHorizontal.vue";
  import SwGsIconBars from "../icons/SwGsIconBars.vue";
  import SwGsIconCameraOff from "../icons/SwGsIconCameraOff.vue";
  import SwButton from "@/components/atoms/SwButton.vue";
  import { SwGsIconPlus, SwGsIconEdit, SwGsIconSave, SwGsIconLongArrowRight } from "../icons";
  import SwGsLayerProductCard from "../layer/SwGsLayerProductCard.vue";
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import { nextTick, computed, ref, onUnmounted, watch} from '@vue/composition-api'

  export default {
    name: "SwGsInstantListing",
    components: {
      SwGsIconLongArrowRight,
      SwGsLayerProductCard,
      SwGsIconCameraOff,
      SwGsIconBars,
      SwGsLayerProductCardHorizontal,
      SwGsIconBroadcast,
      SwButton,
      SfSelect,
      SfLoader,
      SwCheckbox,
      SwGsIconPlus,
      SwGsIconEdit,
      SwGsIconSave,
      SwPluginSlot,
    },
    setup() {
      let intersectionObserver: IntersectionObserver | null;
      const loadMoreButton = ref(null);
      const {
        loadProductStreams,
        productStreams,
        isInstantListingModalOpen,
        currentProducts,
        removeAllSelectedProducts,
        // loadProductsFromStorage,
        saveNewInstantListing,
        createNewInstantListing,
        toggleAutoProductSync,
        toggleProductStreamSelection,
        isCreationMode,
        isEditMode,
        saveInstantListingUpdate,
        isInProductStreamArray,
        autoSyncProducts,
        indexOfFirstSlideInNextGroup,
        isProductSelected,
        toggleProduct,
        scrollLoadInstantListing,
        scrollLoading,
        instantListingProducts,
        instantListingSaving,
        instantListingUpdated,
        addInstantListingProductIds,
        removeInstantListingProductIds,
      } = useInstantListing();

      loadProductStreams();
      // 
      // loadProductsFromStorage();

      const showLoadMoreController = computed(() => currentProducts.value.length < instantListingProducts.value.length);

      const onIntersect = (entries: IntersectionObserverEntry[]) => {
        if (scrollLoading.value) return;
        if (entries && entries[0] && entries[0].isIntersecting) {
          scrollLoadInstantListing();
        }
      };

      const createIntersectionObserver = () => {
        nextTick(() => {
          const button = loadMoreButton.value;
          if (!button) return;
          intersectionObserver = new IntersectionObserver(onIntersect);
          intersectionObserver.observe(button);
        });
      };

      const destroyObserver = () => {
        if (intersectionObserver) {
          intersectionObserver.disconnect();
          intersectionObserver = null;
        }
      };

      watch(currentProducts, () => {
        if (currentProducts.value && !intersectionObserver) {
          createIntersectionObserver();
        }
      });

      watch(showLoadMoreController, (value) => {
        if (!value) {
          destroyObserver();
        }
      });

      watch(instantListingUpdated, () => {
        if (!instantListingUpdated.value.updated) {
          setTimeout(() => {
            addInstantListingProductIds.value = [];
            removeInstantListingProductIds.value = [];
          })
        }
      });

      onUnmounted(() => {
        destroyObserver();
      });

      return {
        productStreams,
        toggleProductStreamSelection,
        currentProducts,
        saveNewInstantListing,
        isCreationMode,
        isEditMode,
        saveInstantListingUpdate,
        isInProductStreamArray,
        instantListingUpdated,
        isInstantListingModalOpen,
        createNewInstantListing,
        toggleAutoProductSync,
        autoSyncProducts,
        instantListingProducts,
        indexOfFirstSlideInNextGroup,
        isProductSelected,
        toggleProduct,
        scrollLoading,
        showLoadMoreController,
        loadMoreButton,
        instantListingSaving,
        removeAllSelectedProducts
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-il-manage-wrapper {
    display: flex;
    flex-direction: row-reverse;
    position: absolute;
    width: 100%;
    top: 5px;
    right: 16px;

    button {
      margin: 0 10px;
    }
  }

  .sw-gs-open-il-modal-btn {
    width: 100%;
    margin-bottom: var(--spacer-sm);
  }

  .sw-gs-il-product-streams-wrapper {
    max-height: 188px;
    overflow-y: scroll;

    .sw-gs-il-product-stream-headline {
      margin-bottom: var(--spacer-xs) !important;
    }

    ::v-deep {
      .sf-checkbox__label {
        font-size: var(--font-size--sm) !important;
      }
    }

  }

  .sw-gs-il-products-wrapper {
    margin-bottom: 20px;
    display: flex;
    flex-wrap: wrap;
    max-height: 600px;
    overflow-y: scroll;
    &-bottom {
      height: 50px;
      width: 100%;
      position: relative;
      button {
        opacity: 0;
        position: absolute;
        top: 0;
        left: 0;
      }
    }
    .sw-gs-il-product-card-wrapper {
      position: relative;
      width: 25%;
      &:hover {
        .sf-checkbox {
          display: block;
        }
      }

      ::v-deep {
        .sf-image--wrapper {
          height: 100px;
        }

        .sf-checkbox {
          position: absolute;
          top: var(--spacer-xs);
          right: var(--spacer-xs);
          z-index: var(--helper-lay-over-sibling-z-index);
          display: none;

          .sf-checkbox__message {
            display: none;
          }

        }

        .sw-gs-layer-product-card {
          width: 100%;
          padding: var(--spacer-2xs);
        }
      }
    }
  }

  .sw-gs-il-actions-wrapper {
    display: flex;
    flex-direction: column;

    .sw-gs-il-actions-content {
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
      margin-bottom: var(--spacer-sm);
    }
    .sw-gs-il-actions-sub-content {
      display: flex;
      justify-content: space-between;
      align-items: center;
      margin-bottom: var(--spacer-sm);
      &-title {
        font-size: 1rem;
      }
      &-remove-btn {
        color: var(--c-danger);
        font-size: 14px;
        font-weight: 400;
        cursor: pointer;
      }
    }
  }

  .slide-info {
    margin-right: 20px;
  }

  .sw-gs-il-product-stream-headline {
    margin-bottom: var(--spacer-xs)
  }

  .sw-gs-update-il-btn {
    width: 60%;
    padding: 10px 20px;
    text-transform: revert;
    min-height: 40px;
    .sf-loader {
      width: 25px;
      height: 25px;
      &__overlay {
        background: transparent;
      }
      svg {
        stroke: white;
      }
    }
  }

  .sw-gs-show-il-create-btns {
    display: flex;
    flex-direction: row;
    justify-content: flex-end;
    align-items: center;

    .sw-gs-show-il-create-btn ,
    .sw-gs-show-il-navigate-btn {
      padding: 10px 15px;
      margin: 0 0 0 20px;
      border-radius: 24px;
    }

  }


  .sw-gs-il-init-filters-wrapper {
    background-color: var(--c-light);
    padding: 10px;
    margin: -10px;
    margin-bottom: 0;
    border-radius: 16px;
  }

  .sw-gs-prevent-click {
    opacity: 0.5;
    pointer-events: none;
  }
</style>
